package com.cicdi.notify.sms.aliyun;

import com.alibaba.fastjson.JSON;
import com.cicdi.notify.*;
import com.cicdi.notify.sms.SmsProvider;
import com.cicdi.notify.template.TemplateManager;
import com.cicdi.notify.template.TemplateProperties;
import com.cicdi.notify.template.TemplateProvider;

/**
 * 阿里云短信通知服务
 * </a>
 */
public class AliyunSmsNotifierProvider implements NotifierProvider, TemplateProvider {

    private final TemplateManager templateManager;

    public AliyunSmsNotifierProvider(TemplateManager templateManager) {
        this.templateManager = templateManager;
    }

    @Override
    public Provider getProvider() {
        return SmsProvider.aliyunSms;
    }

//    public static final DefaultConfigMetadata templateConfig = new DefaultConfigMetadata("阿里云短信模版",
//        "https://help.aliyun.com/document_detail/108086.html")
//            .add("signName", "签名", "", new StringType())
//            .add("code", "模版编码", "", new StringType())
//            .add("phoneNumber", "收信人", "", new StringType());
//
//    public static final DefaultConfigMetadata notifierConfig = new DefaultConfigMetadata("阿里云API配置"
//        ,"https://help.aliyun.com/document_detail/101300.html")
//            .add("regionId", "regionId", "regionId", new StringType())
//            .add("accessKeyId", "accessKeyId", "", new StringType())
//            .add("secret", "secret", "", new StringType());
//
//    @Override
//    public ConfigMetadata getTemplateConfigMetadata() {
//        return templateConfig;
//    }
//
//    @Override
//    public ConfigMetadata getNotifierConfigMetadata() {
//        return notifierConfig;
//    }

    @Override
    public AliyunSmsTemplate createTemplate(TemplateProperties properties) {
        // TODO 验证工具
        //return ValidatorUtils.tryValidate(JSON.parseObject(properties.getTemplate(), AliyunSmsTemplate.class));
        return JSON.parseObject(properties.getTemplate(), AliyunSmsTemplate.class);
    }

    @Override
    public NotifyType getType() {
        return DefaultNotifyType.sms;
    }

    @Override
    public AliyunSmsNotifier createNotifier(NotifierProperties properties) {
        return new AliyunSmsNotifier(properties, templateManager);
    }
}
