package com.cicdi.notify.sms.telecom;

import com.alibaba.fastjson.JSON;
import com.cicdi.notify.*;
import com.cicdi.notify.sms.SmsProvider;
import com.cicdi.notify.sms.aliyun.AliyunSmsNotifier;
import com.cicdi.notify.template.Template;
import com.cicdi.notify.template.TemplateManager;
import com.cicdi.notify.template.TemplateProperties;
import com.cicdi.notify.template.TemplateProvider;

/**
 * @author xueye
 */
public class TelecomSmsNotifierProvider implements NotifierProvider, TemplateProvider {

    private final TemplateManager templateManager;

    public TelecomSmsNotifierProvider(TemplateManager templateManager) {
        this.templateManager = templateManager;
    }

    @Override
    public NotifyType getType() {
        return DefaultNotifyType.sms;
    }

    @Override
    public Provider getProvider() {
        return SmsProvider.telecom;
    }

    @Override
    public Template createTemplate(TemplateProperties properties) {
        return JSON.parseObject(properties.getTemplate(), TelecomSmsTemplate.class);
    }

    @Override
    public Notifier<? extends Template> createNotifier(NotifierProperties properties) {
        return new TelecomSmsNotifier(properties, templateManager);
    }
}
